<h1 align='center'>
    <strong> Assessment Report </strong>
</h1>

<p align='center'>
    Check what's happening under the hood, without even opening it.
</p>

<div align="center">

  <a href="code coverage">![coverage](https://img.shields.io/badge/coverage-98%25-brightgreen)</a>
  <a href="tests">![tests](https://img.shields.io/badge/tests-14%20passed%2C%200%20failed-brightgreen)</a>
  <a href="python version">![sbt_version](https://img.shields.io/badge/python-3.10-blue?logo=python&logoColor=white)</a>

</div>

## **0. Introduction**

The assessment report is a tool that allows you to assess the health of a Kafka cluster as well as the health of the operations performed around it by capturing and analyzing various metrics.

## **1. Metrics captured**

The report generated by this method captures metrics from the following systems:

1. **Kafka**;
2. **Sparql** (_TO BE IMPLEMENTED_);
3. **Telicent Lib** (_TO BE IMPLEMENTED_).

Let's dive into each of them.

### **1.1. Kafka**

All of the metrics captured from Kafka are server metrics, this being said, not metrics are captured from the clients (consumers and/or producers) and they're specific to a topic.

Among the metrics captured, the following are of special interest:

#### `messages_in_per_second`

- **Description:** Measures the rate of incoming messages per second;
- **Unit of measurement:** messages/second;

#### `messages_out_per_second`

- **Description:** Measures the rate of outgoing messages per second;
- **Unit of measurement:** messages/second;

#### `fetch_latency_avg`

- **Description:** Measures the average latency for producing messages to the broker;
- **Unit of measurement:** milliseconds;

#### `produce_latency_avg`

- **Description:** Measures the average latency for producing messages to the broker;
- **Unit of measurement:** milliseconds;

#### `consumer_latency_avg`

- **Description:** Measures the average latency for consuming messages from the broker;
- **Unit of measurement:** milliseconds;

## **A.1. Report Sample**

For mapper pipelines (which envolved data vehiculation from one source to one target topic), the report sample is the following:

```json
[
    {
        "timestamp": "2024-10-24 14:14:33",
        "assessment-test-mapper-geojson-5mb": {
            "messages_in_per_second": 2060,
            "messages_out_per_second": 0.0,
            "fetch_latency_avg": 487.47600064143717,
            "produce_latency_avg": 0.0,
            "consumer_latency_avg": 0.0,
        },
        "assessment-test-geojson-5mb": {
            "messages_in_per_second": 12082,
            "messages_out_per_second": 2416.3999999999996,
            "fetch_latency_avg": 1344.3390906837228,
            "produce_latency_avg": 2416.3999999999996,
            "consumer_latency_avg": 2416.3999999999996,
        }
    }
]
```
